############################################################################
#
#  Program:         SuperLU_DIST
#
#  Module:          make.inc
#
#  Purpose:         Top-level Definitions
#
#  Creation date:   February 4, 1999   version alpha
#
#  Modified:	    September 1, 1999  version 1.0
#                   March 15, 2003     version 2.0
#		    November 1, 2007   version 2.1
#
############################################################################
#
#  The machine (platform) identifier to append to the library names
#
PLAT		= _linux

#
#  The name of the libraries to be created/linked to
#
DSuperLUroot 	= $(HOME)/SuperLU_DIST_2.3
DSUPERLULIB   	= $(DSuperLUroot)/lib/libsuperlu_dist_2.3.a
#
BLASDEF		= -DUSE_VENDOR_BLAS
BLASLIB		= -lblas

# need 64-bit libraries
METISLIB        = -lmetis
PARMETISLIB	= -lparmetis

LIBS	     	= $(DSUPERLULIB) $(BLASLIB) $(PARMETISLIB) $(METISLIB)

#
#  The archiver and the flag(s) to use when building archive (library)
#  If your system has no ranlib, set RANLIB = echo.
#
ARCH         	= ar
# 64-bit:
#ARCHFLAGS    	= -X64 cr
ARCHFLAGS    	= cr
RANLIB       	= ranlib

OMPFLAGS	= -fopenmp

############################################################################
# C compiler setup
# 64-bit
#CC           	= mpcc_r
CC           	= mpicc -fPIC
# CFLAGS should be set to be the C flags that include optimization
#CFLAGS          = -D_SP -qarch=pwr5 -qalias=allptrs -q64 \
#		  -DDEBUGlevel=0 -DPRNTlevel=0 -O3 -D_LONGINT
CFLAGS		= -DDEBUGlevel=0 -DPRNTlevel=0 -O3 -g ${OMPFLAGS}
#
# NOOPTS should be set to be the C flags that turn off any optimization
# 64-bit
#NOOPTS		= -q64
NOOPTS		=

############################################################################
# FORTRAN compiler setup
# 64-bit
#FORTRAN         = mpxlf90_r
FORTRAN         = mpif77 -fpic
#FFLAGS 	= -WF,-Dsp -O3 -Q -qstrict -qfixed -qinit=f90ptr -qarch=pwr5\
#                  -q64 -qintsize=8
FFLAGS		= -O3 ${OMPFLAGS}
############################################################################
# 64-bit
#LOADER	= mpxlf90_r
LOADER	= mpicc

# 64-bit:
#LOADOPTS	= -q64
LOADOPTS	= ${OMPFLAGS}
############################################################################
#  C preprocessor defs for compilation (-DNoChange, -DAdd_, or -DUpCase)
#
#  Need follow the convention of how C calls a Fortran routine.
#
#CDEFS        = -DNoChange
CDEFS        = -DAdd_
