%define ver 5.1.0

Summary:	Solving sparse linear systems of equations by LU factorization
Name:		superlu-dist
Version:	%{ver}
Release:	1
License:	The Regents of the University of California
Group:		Applications/Library
Source0:	http://crd.lbl.gov/~xiaoye/SuperLU/superlu_dist_%{ver}.tar.bz2
Source1:	make.inc
Source2:	Copyright.txt
Patch:		superlu-3.3-static.patch
URL:		http://crd.lbl.gov/~xiaoye/SuperLU/
BuildRoot:	/var/tmp/%{name}-%{version}-root-%(id -u -n)
%ifos linux
BuildArch:	i686 x86_64
Requires:	blas-devel lapack-devel parmetis
%else
AutoReqProv:	no
BuildArch:	x86_64
%endif
Prefix:		/usr

%description
SuperLU_DIST contains a set of subroutines to solve a sparse linear system
A*X=B. It uses Gaussian elimination with static pivoting (GESP).
Static pivoting is a technique that combines the numerical stability of
partial pivoting with the scalability of Cholesky (no pivoting),
to run accurately and efficiently on large numbers of processors.

SuperLU_DIST is a parallel extension to the serial SuperLU library.
It is targeted for the distributed memory parallel machines.
SuperLU_DIST is implemented in ANSI C, and MPI for communications.
Currently, the LU factorization and triangular solution routines,
which are the most time-consuming part of the solution process,
are parallelized. The other routines, such as static pivoting and
column preordering for sparsity are performed sequentially.
This "alpha" release contains double-precision real and double-precision
complex data types.

%prep
%setup -q -n SuperLU_DIST_%{ver}
###%patch -p1
echo 'DSuperLUroot = '$RPM_BUILD_ROOT%{_libdir} > make.inc
echo 'DSUPERLULIB = $(DSuperLUroot)/libsuperlu_dist.a' >> make.inc
grep -v '^DSuperLUroot\|^DSUPERLULIB\|^#' $RPM_SOURCE_DIR/make.inc >> make.inc
/bin/cp -f $RPM_SOURCE_DIR/Copyright.txt .

%build
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/superlu_dist
cd SRC
make
/bin/rm -rf tmp
mkdir tmp
cd tmp
mv $RPM_BUILD_ROOT%{_libdir}/libsuperlu_dist.a .
ar x libsuperlu_dist.a 
/bin/rm -f lsame.o xerbla.o slamch.o dlamch.o
%ifnos darwin
    gcc -shared -o ../libsuperlu_dist.so *.o
%else
    mpicc -dynamiclib -dylinker_install_name %{_libdir}/libsuperlu_dist.dylib \
	-o ../libsuperlu_dist.dylib *.o -llapack -lblas \
					-L%{_libdir} -lparmetis -lmetis
%endif
cd ..
/bin/rm -rf tmp

%install
mkdir -p $RPM_BUILD_ROOT{%{_libdir},%{_includedir}/superlu_dist}
%ifnos darwin
  cp -a SRC/libsuperlu_dist.so $RPM_BUILD_ROOT%{_libdir}/.
%else
  cp -a SRC/libsuperlu_dist.dylib $RPM_BUILD_ROOT%{_libdir}/.
%endif
# TODO: change #include "..." to #include "superlu_dist/..." in *.h, and
# create link superlu_ddefs.h -> superlu_dist/superlu_ddefs.h
/bin/cp -pf SRC/*.h $RPM_BUILD_ROOT%{_includedir}/superlu_dist/.

/bin/chmod -R a+rX $RPM_BUILD_ROOT/.

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%postun
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%files
%doc Copyright.txt README DOC/ug.pdf
%{_includedir}/*/*.h
%{_libdir}/lib*

%changelog
* Thu Jan 10 2008 Zhang Linbo <zlb@lsec.cc.ac.cn>
- Release 2.0-4: remove prototypes of BLAS/LAPACK routines from installed
  header files.
* Wed Dec 26 2007 Zhang Linbo <zlb@lsec.cc.ac.cn>
- Release 2.0-3: remove lsame.o xerbla.o slamch.o dlamch.o (use BLAS/LAPACK)
